﻿package FMPhysics{
	import flash.geom.Point;
	import flash.display.Sprite;

	import FMPhysics.PhysicalPoint;
	import FMPhysics.Functions;

	public class BezierShape{
		public var loc:Array = new Array();
		public var openFlag:Array = new Array();
		public var kijun:Point = new Point();
		
		function BezierShape(xml:XML = null){
			if(xml != null){
				for each(var path:XML in xml.path){
					if(path.attribute("openFlag") == "true")	makePath(true);
					else										makePath(false);
					var preX0:Number = 0;
					var preY0:Number = 0;
					for each(var segment: XML in path.segment){
						var sts:Array = segment.toString().split(" ");
						if(sts[sts.length-1].toLowerCase() == "m"){
							addSegment([new PhysicalPoint(Number(sts[0]), Number(sts[1]))]);
						}else if(sts[sts.length-1].toLowerCase() == "l"){
							addSegment([new PhysicalPoint(Number(sts[0]), Number(sts[1]))]);
						}else if(sts[sts.length-1].toLowerCase() == "c"){
							addSegment([new PhysicalPoint(Number(sts[0]), Number(sts[1])), new PhysicalPoint(Number(sts[2]), Number(sts[3])), new PhysicalPoint(Number(sts[4]), Number(sts[5]))]);
						}else if(sts[sts.length-1].toLowerCase() == "y"){
							addSegment([new PhysicalPoint(Number(sts[0]), Number(sts[1])), new PhysicalPoint(Number(sts[2]), Number(sts[3])), new PhysicalPoint(Number(sts[2]), Number(sts[3]))]);
						}else if(sts[sts.length-1].toLowerCase() == "v"){
							addSegment([new PhysicalPoint(preX0, preY0), new PhysicalPoint(Number(sts[0]), Number(sts[1])), new PhysicalPoint(Number(sts[2]), Number(sts[3]))]);
						}
						preX0 = Number(sts[sts.length-3]);
						preY0 = Number(sts[sts.length-2]);
					}
				}
			}
		}
		
		public function makePath(openF:Boolean = true){
			loc.push(new Array());
			openFlag.push(openF);
		}
		
		public function addSegment(ar:Array){
			if(ar != null){
				for(var i:Number = 0; i < ar.length; ++i){
					if(ar[i] is Point){
						
					}else{
						trace("Array引数の中にPhysicalPointもしくはPoint型ではないものが含まれています。");
						return;
					}
				}
				loc[loc.length-1].push(ar);
			}
		}
		
		public function duplicate(){
			var ret:BezierShape = new BezierShape();
			ret.kijun = new Point(kijun.x, kijun.y);
			for(var i:Number = 0; i < loc.length; ++i){
				ret.makePath(openFlag[i]);
				for(var j:Number = 0; j < loc[i].length; ++j){
					var seg:Array = new Array();
					for(var k:Number = 0; k < loc[i][j].length; ++k){
						seg.push(new PhysicalPoint(loc[i][j][k].x, loc[i][j][k].y))
					}
					ret.addSegment(seg);
				}
			}
			return ret;
		}
		
		public function drawShape(sp:Sprite){
			for(var i:Number = 0; i < loc.length; ++i){
				for(var j:Number = 0; j < loc[i].length; ++j){
					if(j == 0){
						sp.graphics.moveTo(loc[i][j][0].x, loc[i][j][0].y);						
					}else if(loc[i][j].length == 1){
						sp.graphics.lineTo(loc[i][j][0].x, loc[i][j][0].y);
					}else if(loc[i][j].length == 3){
						Functions.bezierCurveTo(loc[i][j-1][loc[i][j-1].length-1].x, loc[i][j-1][loc[i][j-1].length-1].y, loc[i][j][0].x, loc[i][j][0].y, loc[i][j][1].x, loc[i][j][1].y, loc[i][j][2].x, loc[i][j][2].y, sp);
					}
				}
			}
		}

		public function drawControl(sp:Sprite){
			for(var i:Number = 0; i < loc.length; ++i){
				for(var j:Number = 0; j < loc[i].length; ++j){
					if(loc[i][j].length == 1){
						if(j != loc[i].length-1){
							if(loc[i][j+1].length == 3){
								sp.graphics.moveTo(loc[i][j][0].x, loc[i][j][0].y);
								sp.graphics.lineTo(loc[i][j+1][0].x, loc[i][j+1][0].y);
							}
						}
						sp.graphics.beginFill(0xFFFFFF);
						sp.graphics.drawCircle(loc[i][j][0].x, loc[i][j][0].y, 3);
						sp.graphics.endFill();
					}else if(loc[i][j].length == 3){
						sp.graphics.moveTo(loc[i][j][1].x, loc[i][j][1].y);
						sp.graphics.lineTo(loc[i][j][2].x, loc[i][j][2].y);
						if(j != loc[i].length-1){
							if(loc[i][j+1].length == 3){
								sp.graphics.lineTo(loc[i][j+1][0].x, loc[i][j+1][0].y);
							}
						}
						sp.graphics.beginFill(0xFFFFFF);
						sp.graphics.drawRect(loc[i][j][0].x-2, loc[i][j][0].y-2, 4, 4);
						sp.graphics.endFill();
						sp.graphics.beginFill(0xFFFFFF);
						sp.graphics.drawRect(loc[i][j][1].x-2, loc[i][j][1].y-2, 4, 4);
						sp.graphics.endFill();
						sp.graphics.beginFill(0xFFFFFF);
						sp.graphics.drawCircle(loc[i][j][2].x, loc[i][j][2].y, 3);
						sp.graphics.endFill();
					}
				}
			}
		}

		public function expand(baiX:Number, baiY:Number){
			for(var i:Number = 0; i < loc.length; ++i){
				for(var j:Number = 0; j < loc[i].length; ++j){
					for(var k:Number = 0; k < loc[i][j].length; ++k){
						loc[i][j][k].x -= kijun.x;
						loc[i][j][k].y -= kijun.y;
						loc[i][j][k].x *= baiX;
						loc[i][j][k].y *= baiY;
						loc[i][j][k].x += kijun.x;
						loc[i][j][k].y += kijun.y;
					}
				}
			}
		}

		public function shift(shiftX:Number, shiftY:Number){
			kijun.x += shiftX;
			kijun.y += shiftY;
			for(var i:Number = 0; i < loc.length; ++i){
				for(var j:Number = 0; j < loc[i].length; ++j){
					for(var k:Number = 0; k < loc[i][j].length; ++k){
						loc[i][j][k].x += shiftX;
						loc[i][j][k].y += shiftY;
					}
				}
			}
		}
		
		public function getAnchorPoints(pt:Point):PhysicalPoint{
			if(pt != null){
				for(var i:Number = 0; i < loc.length; ++i){
					for(var j:Number = 0; j < loc[i].length; ++j){
						if(loc[i][j].length == 1){
							if(Point.distance(loc[i][j][0], pt) < 4){
								return(loc[i][j][0]);
							}
						}
						if(loc[i][j].length == 3){
							if(Point.distance(loc[i][j][2], pt) < 4){
								return(loc[i][j][2]);
							}
						}
					}
				}
			}
			return null;
		}
		
		public function getHokoPoints(pt:Point):Array{
			if(pt != null){
				var ret:Array = new Array();
				for(var i:Number = 0; i < loc.length; ++i){
					for(var j:Number = 0; j < loc[i].length; ++j){
						if(loc[i][j].length == 3){
							if(Point.distance(loc[i][j][0], pt) < 4){
								ret.push(loc[i][j][0]);
							}
							if(Point.distance(loc[i][j][1], pt) < 4){
								ret.push(loc[i][j][1]);
							}
						}
					}
				}
				if(ret.length > 0)	return ret;
				else				return null;
			}
			return null;
		}
		
		public function getHokoPoints2(pt:Point):Array{
			var ret:Array = new Array();
			if(pt != null){
				for(var i:Number = 0; i < loc.length; ++i){
					for(var j:Number = 0; j < loc[i].length; ++j){
						if(loc[i][j].length == 1){
							if(loc[i][j][0] == pt){
								if(j != loc[i].length-1){
									if(loc[i][j+1].length == 3){
										ret.push(loc[i][j+1][0]);
									}
								}
							}
						}
						if(loc[i][j].length == 3){
							if(loc[i][j][2] == pt){
								ret.push(loc[i][j][1]);
								if(j != loc[i].length-1){
									if(loc[i][j+1].length == 3){
										ret.push(loc[i][j+1][0]);
									}
								}
							}
						}
					}
				}
				if(ret.length > 0)	return ret;
				else				return null;
			}
			return null;
		}
	}
}