﻿package FMPhysics{
  import flash.display.Sprite;
  import flash.events.MouseEvent;
  import flash.text.TextField;
  import flash.text.TextFormat;
  import flash.text.TextFormatAlign;
  
  public class FMButton extends Sprite{
    
	var captionTF:TextField = new TextField();
	var cover:Sprite = new Sprite();
	public var pressed:Sprite = new Sprite();
	public var jotai:Boolean = false;
	var highlightCol:uint;
	var pressedCol:uint;
	var baseCol:uint;
	var basewakuCol:uint;
	var textCol:uint;
	public static const HIGHLIGHT_COLOR:uint = 0xCCCCCC;
	public static const PRESSED_COLOR:uint = 0xEEEEEE;
	public static const BASE_COLOR:uint = 0xAAAAAA;
	public static const BASEWAKU_COLOR:uint = 0x777777;
	public static const TEXT_COLOR:uint = 0x333333;
	public static const TEXT_SIZE:Number = 10;
	
	function FMButton(caption:String="untitled", w:Number=0, h:Number = 0, ts:Number=TEXT_SIZE, bc:uint=BASE_COLOR, bwc:uint=BASEWAKU_COLOR, tc:uint=TEXT_COLOR, pc:uint=PRESSED_COLOR, hc:uint=HIGHLIGHT_COLOR){
		
		highlightCol = hc;
		pressedCol = pc;
		baseCol = bc;
		basewakuCol = bwc;
		textCol = tc;
		
		var tfm:TextFormat = captionTF.getTextFormat();
		tfm.align = TextFormatAlign.CENTER;
		tfm.font = "ＭＳ Ｐゴシック";
		tfm.size = ts;
		captionTF.defaultTextFormat = tfm;
		captionTF.text = caption;
		captionTF.textColor = textCol;
		
		if(w == 0){
			captionTF.width = captionTF.textWidth+30;
		}else{
			captionTF.width = w;
		}
		if(h == 0){
			captionTF.height = captionTF.textHeight+4;
		}else{
			captionTF.height = h;
		}
		
		var haba:Number = captionTF.width;
		var takasa:Number = captionTF.height;

		cover.graphics.lineStyle(1, 0);
		cover.graphics.beginFill(highlightCol);
		cover.graphics.drawRect(0, 0, haba, takasa);
		cover.graphics.endFill();
		cover.visible = false;
		addChild(cover);

		pressed.graphics.lineStyle(1, 0);
		pressed.graphics.beginFill(pressedCol);
		pressed.graphics.drawRect(0, 0, haba, takasa);
		pressed.graphics.endFill();
		pressed.visible = false;
		addChild(pressed);

		addChild(captionTF);

		addEventListener(MouseEvent.ROLL_OVER, function(ev:MouseEvent){cover.visible = true;});
		addEventListener(MouseEvent.ROLL_OUT, function(ev:MouseEvent){cover.visible = false;});
		addEventListener(MouseEvent.MOUSE_DOWN, function(ev:MouseEvent){pressed.visible = true;});
		addEventListener(MouseEvent.MOUSE_UP, function(ev:MouseEvent){pressed.visible = false;});
		
		this.graphics.lineStyle(1, basewakuCol);
		this.graphics.beginFill(baseCol);
		this.graphics.drawRect(0, 0, haba, takasa);
		this.graphics.endFill();
		
		this.mouseChildren = false;
		this.useHandCursor = true;
		this.buttonMode = true;
	}
    
	public function setCaption(st:String){
		captionTF.text = st;
	}
  }
}
