﻿package FMPhysics{
	import flash.display.Sprite;
	import flash.geom.Point;
	import flash.display.BitmapData;
	import flash.geom.Rectangle;
	
	public class Functions {
	
		public static function hsbToRgb(h:Number,s:Number,b:Number):uint {
			while (h<0) {
				h+=360;
			}
			while (h>=360) {
				h-=360;
			}
			
			var h2:Number = Math.floor(h/60);
			var f:Number = h/60-h2;
			var parFull:Number = 255;
			var parEmp:Number = 0;
			var parZoka:Number = 255*f;
			var parGensho:Number = 255*(1-f);
			var red:Number = 0
			var green:Number = 0
			var blue:Number = 0;
			switch (h2) {
				case 0 :
					red = parFull;
					green = parZoka;
					blue = parEmp;
					break;
				case 1 :
					red = parGensho;
					green = parFull;
					blue = parEmp;
					break;
				case 2 :
					red = parEmp;
					green = parFull;
					blue = parZoka;
					break;
				case 3 :
					red = parEmp;
					green = parGensho;
					blue = parFull;
					break;
				case 4 :
					red = parZoka;
					green = parEmp;
					blue = parFull;
					break;
				case 5 :
					red = parFull;
					green = parEmp;
					blue = parGensho;
					break;
			}
			
			var max:Number = Math.max(Math.max(red, green), blue);
			red = max - (max-red)*s;
			green = max - (max-green)*s;
			blue = max - (max-blue)*s;
			
			red *= b;
			green *= b;
			blue *= b;
			
			var ret:uint=int(red)<<16|int(green)<<8|int(blue);
			
			return ret;
		}
		
		public static function rgbToHsb(rgb:uint):Array{
			var ret:Array = new Array();
			
			var red:Number = rgb >> 16 & 0xFF;
			var green:Number = rgb >> 8 & 0xFF;
			var blue:Number = rgb >> 0 & 0xFF;
			
			var max:Number = Math.max(Math.max(red, green), blue);
			var min:Number = Math.min(Math.min(red, green), blue);
			
			
			if(red == green && green == blue){
				ret[0] = ret[1] = ret[2] = 0;
				return ret;
			}else{
				if(max == red && min == blue){
					ret[0] = 0 + (green-min)/(max-min)*60;
				}else if(max == green && min == blue){
					ret[0] = 60 + (1-(red-min)/(max-min))*60;
				}else if(max == green && min == red){
					ret[0] = 120 + (blue-min)/(max-min)*60;
				}else if(max == blue && min == red){
					ret[0] = 180 + (1-(green-min)/(max-min))*60;
				}else if(max == blue && min == green){
					ret[0] = 240 + (red-min)/(max-min)*60;
				}else if(max == red && min == green){
					ret[0] = 300 + (1-(blue-min)/(max-min))*60;
				}
				
				ret[1] = (max-min)/max;
				
				ret[2] = max/255;
				
				
				return ret;
			}
		}
		
		public static function getHeikinColor(bmd:BitmapData, xx:Number, yy:Number, w:Number, h:Number):uint{
			var rrr: uint = 0;
			var ggg: uint = 0;
			var bbb: uint = 0;
			for(var y: Number = yy; y < yy+h; ++y){
				for(var x: Number = xx; x < xx+w; ++x){
					var col: uint = bmd.getPixel(x, y);
					rrr += 0xFF & col >> 16;
					ggg += 0xFF & col >> 8;
					bbb += 0xFF & col >> 0;
				}
			}
			rrr /= w*h;
			ggg /= w*h;
			bbb /= w*h;
			
			return int(rrr) << 16 | int(ggg) << 8 | int(bbb);
		}
	}
}