﻿package FMPhysics{
	import flash.display.Sprite;
	import flash.geom.Point;
	import flash.display.BitmapData;
	import flash.geom.Rectangle;
	
	public class Functions {
	
		public static function hsbToRgb(h:Number,s:Number,b:Number):uint {
			while (h<0) {
				h+=360;
			}
			while (h>=360) {
				h-=360;
			}
			
			var h2:Number = Math.floor(h/60);
			var f:Number = h/60-h2;
			var parFull:Number = 255;
			var parEmp:Number = 0;
			var parZoka:Number = 255*f;
			var parGensho:Number = 255*(1-f);
			var red:Number = 0
			var green:Number = 0
			var blue:Number = 0;
			switch (h2) {
				case 0 :
					red = parFull;
					green = parZoka;
					blue = parEmp;
					break;
				case 1 :
					red = parGensho;
					green = parFull;
					blue = parEmp;
					break;
				case 2 :
					red = parEmp;
					green = parFull;
					blue = parZoka;
					break;
				case 3 :
					red = parEmp;
					green = parGensho;
					blue = parFull;
					break;
				case 4 :
					red = parZoka;
					green = parEmp;
					blue = parFull;
					break;
				case 5 :
					red = parFull;
					green = parEmp;
					blue = parGensho;
					break;
			}
			
			var max:Number = Math.max(Math.max(red, green), blue);
			red = max - (max-red)*s;
			green = max - (max-green)*s;
			blue = max - (max-blue)*s;
			
			red *= b;
			green *= b;
			blue *= b;
			
			var ret:uint=int(red)<<16|int(green)<<8|int(blue);
			
			return ret;
		}
		
		public static function rgbToHsb(rgb:uint):Array{
			var ret:Array = new Array();
			
			var red:Number = rgb >> 16 & 0xFF;
			var green:Number = rgb >> 8 & 0xFF;
			var blue:Number = rgb >> 0 & 0xFF;
			
			var max:Number = Math.max(Math.max(red, green), blue);
			var min:Number = Math.min(Math.min(red, green), blue);
			
			
			if(red == green && green == blue){
				ret[0] = ret[1] = ret[2] = 0;
				return ret;
			}else{
				if(max == red && min == blue){
					ret[0] = 0 + (green-min)/(max-min)*60;
				}else if(max == green && min == blue){
					ret[0] = 60 + (1-(red-min)/(max-min))*60;
				}else if(max == green && min == red){
					ret[0] = 120 + (blue-min)/(max-min)*60;
				}else if(max == blue && min == red){
					ret[0] = 180 + (1-(green-min)/(max-min))*60;
				}else if(max == blue && min == green){
					ret[0] = 240 + (red-min)/(max-min)*60;
				}else if(max == red && min == green){
					ret[0] = 300 + (1-(blue-min)/(max-min))*60;
				}
				
				ret[1] = (max-min)/max;
				
				ret[2] = max/255;
				
				
				return ret;
			}
		}
		
		public static function getHeikinColor(bmd:BitmapData, xx:Number, yy:Number, w:Number, h:Number):uint{
			var rrr: uint = 0;
			var ggg: uint = 0;
			var bbb: uint = 0;
			for(var y: Number = yy; y < yy+h; ++y){
				for(var x: Number = xx; x < xx+w; ++x){
					var col: uint = bmd.getPixel(x, y);
					rrr += 0xFF & col >> 16;
					ggg += 0xFF & col >> 8;
					bbb += 0xFF & col >> 0;
				}
			}
			rrr /= w*h;
			ggg /= w*h;
			bbb /= w*h;
			
			return int(rrr) << 16 | int(ggg) << 8 | int(bbb);
		}
		
		public static function getKakomi(pt:Array):Array{
			if(pt.length > 0){
				var maxPt:Point = null;
				var minPt:Point = null;
				
				var retPt:Array = new Array();
				
				var minVal:Number = 100000;
				var maxVal:Number = -100000;
				for(var i:Number = 0; i < pt.length; ++i){
					if(minVal > pt[i].x){
						minPt = pt[i];
						minVal = pt[i].x;
					}else if(minVal == pt[i].x){
						if(minPt.y < pt[i].y){
							minPt = pt[i];
						}
					}
				
					if(maxVal < pt[i].x){
						maxPt = pt[i];
						maxVal = pt[i].x;
					}
				}
				retPt.push(minPt);
			
				var korePt:Point = null;
				for(var j:Number = 0; j < pt.length; ++j){
					if(minPt == maxPt)	break;
					var maxK:Number = -100000;
					for(var k:Number = 0; k < pt.length; ++k){
						if(minPt != pt[k]){
							if(pt[k].x > minPt.x){
								if(maxK < (pt[k].y - minPt.y)/(pt[k].x - minPt.x)){
									maxK = (pt[k].y - minPt.y)/(pt[k].x - minPt.x);
									korePt = pt[k];
								}
							}
						}
					}
					retPt.push(korePt);
					minPt = korePt;
				}
				
				minVal = 100000;
				maxVal = -100000;
				for(var m:Number = 0; m < pt.length; ++m){
					if(minVal > pt[m].x){
						minPt = pt[m];
						minVal = pt[m].x;
					}
					if(maxVal < pt[m].x){
						maxPt = pt[m];
						maxVal = pt[m].x;
					}else if(maxVal == pt[m].x){
						if(maxPt.y > pt[m].y){
							maxPt = pt[m];
						}
					}
				
				}
				
				if(retPt[retPt.length-1] != maxPt){
					retPt.push(maxPt);
				}
				
				korePt = null;
				for(var n:Number = 0; n < pt.length; ++n){
					if(maxPt == minPt)	break;
					maxK = -100000;
					for(var q:Number = 0; q < pt.length; ++q){
						if(maxPt != pt[q]){
							if(pt[q].x < maxPt.x){
								if(maxK < (pt[q].y - maxPt.y)/(pt[q].x - maxPt.x)){
									maxK = (pt[q].y - maxPt.y)/(pt[q].x - maxPt.x);
									korePt = pt[q];
								}
							}
						}
					}
					retPt.push(korePt);
					maxPt = korePt;
				}
				
				if(retPt.length > 1 && retPt[retPt.length-1].x == retPt[0].x && retPt[retPt.length-1].y == retPt[0].y){
					retPt.pop();
				}
				
				return retPt;
			}else{
				return null;
			}
		}
		
		public static function jushin(pt:Array):Point{
			if(pt != null){
				if(pt.length == 0){
					return new Point(0, 0);
				}else if(pt.length == 1){
					return new Point(pt[0].x, pt[0].y);
				}else if(pt.length == 2){
					return new Point((pt[0].x+pt[1].x)/2, (pt[0].y+pt[1].y)/2);
				}else{
					var s:Number = 0;
					for(var i:Number = 0; i < pt.length; ++i){
						s += (pt[i].x+pt[(i+1)%pt.length].x)*(pt[(i+1)%pt.length].y-pt[i].y);
					}
					s /= 2;
					
					var gx:Number = 0;
					var gy:Number = 0;
					for(var j:Number = 0; j < pt.length; ++j){
						gx += (pt[j].x*pt[j].x + pt[j].x*pt[(j+1)%pt.length].x + pt[(j+1)%pt.length].x*pt[(j+1)%pt.length].x)*(pt[(j+1)%pt.length].y - pt[j].y);
						gy += (pt[j].y*pt[j].y + pt[j].y*pt[(j+1)%pt.length].y + pt[(j+1)%pt.length].y*pt[(j+1)%pt.length].y)*(pt[j].x - pt[(j+1)%pt.length].x);
					}
					gx /= s*6;
					gy /= s*6;
					return new Point(gx, gy);
				}
			}else{
				return null;
			}
		}
	}
}