﻿package{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.utils.Timer;
	import flash.events.TimerEvent;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	
	import FMPhysics.PhysicalPoint;
	import FMPhysics.Functions;
	
	public class FurikoTakakkei extends MovieClip{
		var base:Sprite = new Sprite();
		var pt:Array = new Array();
		
		var shikiso:Number = 0;
		var rotatePt:PhysicalPoint = new PhysicalPoint();
		var preAngle:Number;
		const saishoKaku:Number = 3;
		
		var bitmapdata:BitmapData;
		
		var blackCover:Sprite = new Sprite();
		
		var pressed:Boolean = false;
		var curMouse:Point;
		var preMouse:Point;
		
		function FurikoTakakkei(){
			bitmapdata = new BitmapData(stage.stageWidth, stage.stageHeight, false, 0x000000);
			addChild(new Bitmap(bitmapdata));
		
			blackCover.graphics.lineStyle(0, 0, 0);
			blackCover.graphics.beginFill(0, .05);
			blackCover.graphics.drawRect(0, 0, stage.stageWidth, stage.stageHeight);
			blackCover.graphics.endFill();
			
			rotatePt.kb = 0.98;
			preAngle = rotatePt.angle;
			curMouse = new Point(this.mouseX, this.mouseY);

			stage.addEventListener(MouseEvent.MOUSE_DOWN, onMDown);
			stage.addEventListener(MouseEvent.MOUSE_UP, onMUp);

			var delTimer:Timer = new Timer(10000);
			delTimer.addEventListener(TimerEvent.TIMER, delLoop);
			delTimer.start();

			var timer:Timer = new Timer(33);
			timer.addEventListener(TimerEvent.TIMER, loop);
			timer.start();
		}
		
		function onMDown(ev:MouseEvent){
			pressed  = true;
			pt.push(new Point(ev.target.mouseX, ev.target.mouseY));
			var dire = rotatePt.angle;
			while(dire > Math.PI)	dire -= Math.PI*2;
			while(dire < -Math.PI)	dire += Math.PI*2;
			if(dire < Math.PI/2 && dire > -Math.PI/2)	rotatePt.setKakuKasokudo(-100);
			else										rotatePt.setKakuKasokudo(100);
			
			changeState();
		}
		
		function onMUp(ev:MouseEvent){
			pressed = false;
		}
		
		function delLoop(event:TimerEvent):void{
			if(pt.length > saishoKaku){
				pt.shift();
				changeState();
			}
		}
		
		function changeState(){
			if(pt.length > 1){
				var ppt:Array = Functions.getKakomi(pt);
				var jpt:Point = Functions.jushin(ppt);
				if(jpt != null){
					var dire:Number = Math.atan2(jpt.y - pt[pt.length-1].y, jpt.x - pt[pt.length-1].x);
					rotatePt.angle = dire;
					preAngle = dire;
				}
			}
		}
		
		function loop(event:TimerEvent):void{
			preMouse=curMouse;
			curMouse=new Point(this.mouseX,this.mouseY);

			var ppt:Array = Functions.getKakomi(pt);
			var jpt:Point = Functions.jushin(ppt);
			if(pressed){
				for(var i:Number = 0; i < pt.length; ++i){
					pt[i].x += (curMouse.x - preMouse.x);
					pt[i].y += (curMouse.y - preMouse.y);
				}
				
				var mAngle:Number = Math.atan2(curMouse.y - preMouse.y, curMouse.x - preMouse.x);
				mAngle += Math.PI;
				var par:Number = Point.distance(curMouse, jpt)*Point.distance(preMouse, curMouse)*0.01;
				rotatePt.setKakuKasokudo2(mAngle, par);
			}
			
			rotatePt.setKakuKasokudo2(Math.PI/2, 10);
			for(var j:Number = 0; j < pt.length-1; ++j){
				var p1x:Number = pt[j].x - pt[pt.length-1].x;
				var p1y:Number = pt[j].y - pt[pt.length-1].y;
				var p2x:Number = p1x*Math.cos(rotatePt.angle-preAngle) - p1y*Math.sin(rotatePt.angle-preAngle);
				var p2y:Number = p1x*Math.sin(rotatePt.angle-preAngle) + p1y*Math.cos(rotatePt.angle-preAngle);
				var p3x:Number = p2x + pt[pt.length-1].x;
				var p3y:Number = p2y + pt[pt.length-1].y;
				pt[j].x = p3x;
				pt[j].y = p3y;
			}
			
			shikiso += 1;
			var col:uint = Functions.hsbToRgb(shikiso, 1, 1);
			base.graphics.clear();
			if(jpt != null){
				base.graphics.lineStyle(0, 0, 0);
				base.graphics.beginFill(0xFFFFFF);
				base.graphics.drawCircle(jpt.x, jpt.y, 2);
				base.graphics.endFill();
			}
			if(ppt != null){
				base.graphics.lineStyle(1, col, 0.5);
				base.graphics.moveTo(ppt[0].x, ppt[0].y);
				base.graphics.beginFill(col, 0.1);
				for(var k:Number = 1; k < ppt.length; ++k){
					base.graphics.lineTo(ppt[k].x, ppt[k].y);
				}
				base.graphics.lineTo(ppt[0].x, ppt[0].y);
				base.graphics.endFill();
			}
			for(var m:Number = 0; m < pt.length; ++m){
				base.graphics.lineStyle(0, 0, 0);
				base.graphics.beginFill(col, 0.5);
				base.graphics.drawCircle(pt[m].x, pt[m].y, 4);
				base.graphics.endFill();
			}
			
			/*
			if(pt.length > 0){
				rotatePt.x = pt[pt.length-1].x;
				rotatePt.y = pt[pt.length-1].y;
				base.graphics.lineStyle(1, 0xFFFFFF);
				base.graphics.moveTo(rotatePt.x, rotatePt.y);
				base.graphics.lineTo(rotatePt.x+100*Math.cos(rotatePt.angle), rotatePt.y+100*Math.sin(rotatePt.angle));
			}
			*/
			
			bitmapdata.draw(blackCover);
			bitmapdata.draw(base);
			
			preAngle = rotatePt.angle;
		}
	}
}
