﻿package FMPhysics{
	import flash.utils.Timer;
	import flash.events.TimerEvent;
	import flash.geom.Point;
	
	public class PhysicalPoint extends Point{
		public var vx:Number, vy:Number;
		public var ax:Number, ay:Number;
		public var b:Number;
		public var sakkiTime:Number;
		public var timer:Timer;
		
		public var preX:Number, preY:Number;
				
		public var kb:Number;
		public var angle:Number;
		public var preAngle:Number;
		public var kakusokudo:Number;
		public var kakukasokudo:Number;

		public var limitter:Number = 0.3;

		function PhysicalPoint(xx: Number=0, yy: Number=0, an:Number = 0){
			x = xx;      y = yy;
			preX = xx;		preY = yy;
			b = 0.9;
			vx = 0;      vy = 0;
			ax = 0;      ay = 0;
			
			angle = an;
			preAngle = an;
			kb = 0.9;
			kakusokudo = 0;
			kakukasokudo = 0;
			
			sakkiTime = new Date().getTime();
			
			timer = new Timer(33);
			timer.addEventListener(TimerEvent.TIMER, loop);
			timer.start();
		}
		
		function loop(event:TimerEvent):void{
			var nowTime:Number = new Date().getTime();
			var t:Number = (nowTime - sakkiTime)/1000;
			
			if(t > limitter)	t = limitter;
			
			preX = x;
			preY = y;
			
			x += vx*t + 0.5*ax*t*t;
			y += vy*t + 0.5*ay*t*t;
			
			vx += ax*t;
			vy += ay*t;
			
			vx *= b;
			vy *= b;
			
			ax = 0;
			ay = 0;
			
			preAngle = angle;
			angle += kakusokudo*t + 0.5*kakukasokudo*t*t;
			kakusokudo += kakukasokudo*t;
			
			kakusokudo *= kb;

			kakukasokudo = 0;
			
			sakkiTime = nowTime;
		}
		
		public function setKasokudo(aax:Number=0, aay:Number=0):void{
			ax += aax;
			ay += aay;
		}
		
		public function setKasokudoByPolar(r:Number=0, dire:Number=0):void{
			ax += r*Math.cos(dire);
			ay += r*Math.sin(dire);
		}
		
		public function setKakuKasokudo(aan:Number=0){
			kakukasokudo += aan;
		}
		
		public function setKakuKasokudo2(dire:Number, val:Number){
			var aan:Number = val*Math.sin(dire-angle);
			setKakuKasokudo(aan);
		}
	}
}