﻿package{
	
	import flash.display.MovieClip;
	import flash.utils.Timer;
	import flash.events.TimerEvent;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.geom.Rectangle;

	import FMPhysics.PhysicalPoint;
	import FMPhysics.Functions;
	
	public class WaterVoronoi extends MovieClip{
		
		var pt:Array = new Array();
		
		function WaterVoronoi(){
			for(var i:Number = 0; i < 20; ++i){
				pt.push(new PhysicalPoint(Math.random()*stage.stageWidth, Math.random()*stage.stageHeight));
			}
			
			var timer:Timer = new Timer(33);
			timer.addEventListener(TimerEvent.TIMER, loop);
			timer.start();
		}

		function loop(event:TimerEvent):void{
			pt[0].setKasokudo((mouseX-pt[0].x)*10, (mouseY-pt[0].y)*10);
			
			for(var i:Number = 0; i < pt.length; ++i){
				for(var j:Number = 0; j < pt.length; ++j){
					if(i != j){
						var dist:Number = Point.distance(pt[j], pt[i]);
						dist = Math.max(100-dist, 0)/100;
						var dire:Number = Math.atan2(pt[i].y - pt[j].y, pt[i].x - pt[j].x);
						
						pt[i].setKasokudoByPolar(dist*2000, dire);
					}
				}
				if(pt[i].x < 50)	pt[i].setKasokudo(500, 0);
				if(pt[i].y < 50)	pt[i].setKasokudo(0, 500);
				if(pt[i].x > stage.stageWidth-50)	pt[i].setKasokudo(-500, 0);
				if(pt[i].y > stage.stageHeight-50)	pt[i].setKasokudo(0, -500);
			}
			
			var areas:Array = Functions.getVoronoiAreas(pt, new Rectangle(10, 10, stage.stageWidth-20, stage.stageHeight-20));
			if(areas != null){
				for(var m:Number = 0; m < areas.length; ++m){
					var jushin:Point = Functions.jushin(areas[m]);
					if(jushin != null){
						for(var n:Number = 0; n < areas[m].length; ++n){
							areas[m][n].x += (jushin.x - areas[m][n].x)*0.05;
							areas[m][n].y += (jushin.y - areas[m][n].y)*0.05;
						}
					}
				}
			}
			
			this.graphics.clear();
			if(areas != null){
				for(var k:Number = 0; k < areas.length; ++k){
					if(k == 0){
						this.graphics.lineStyle(2, 0xFFFFFF);
						Functions.fillRing(areas[k], this, 0x888888);
					}else{
						this.graphics.lineStyle(2, 0x888888);
						Functions.fillRing(areas[k], this, 0xFFFFFF);
					}
					//this.graphics.lineStyle(1, 0x000000);
					//Functions.drawPolygon(areas[k], this);
					//this.graphics.drawCircle(pt[k].x, pt[k].y, 3);
				}
			}
		}
	}
}
