﻿package FMPhysics{
	import flash.display.Sprite;
	import flash.geom.Point;
	import flash.display.BitmapData;
	import flash.geom.Rectangle;
	
	public class Functions {
	
		public static function hsbToRgb(h:Number,s:Number,b:Number):uint {
			while (h<0) {
				h+=360;
			}
			while (h>=360) {
				h-=360;
			}
			
			var h2:Number = Math.floor(h/60);
			var f:Number = h/60-h2;
			var parFull:Number = 255;
			var parEmp:Number = 0;
			var parZoka:Number = 255*f;
			var parGensho:Number = 255*(1-f);
			var red:Number = 0
			var green:Number = 0
			var blue:Number = 0;
			switch (h2) {
				case 0 :
					red = parFull;
					green = parZoka;
					blue = parEmp;
					break;
				case 1 :
					red = parGensho;
					green = parFull;
					blue = parEmp;
					break;
				case 2 :
					red = parEmp;
					green = parFull;
					blue = parZoka;
					break;
				case 3 :
					red = parEmp;
					green = parGensho;
					blue = parFull;
					break;
				case 4 :
					red = parZoka;
					green = parEmp;
					blue = parFull;
					break;
				case 5 :
					red = parFull;
					green = parEmp;
					blue = parGensho;
					break;
			}
			
			var max:Number = Math.max(Math.max(red, green), blue);
			red = max - (max-red)*s;
			green = max - (max-green)*s;
			blue = max - (max-blue)*s;
			
			red *= b;
			green *= b;
			blue *= b;
			
			var ret:uint=int(red)<<16|int(green)<<8|int(blue);
			
			return ret;
		}
		
		public static function rgbToHsb(rgb:uint):Array{
			var ret:Array = new Array();
			
			var red:Number = rgb >> 16 & 0xFF;
			var green:Number = rgb >> 8 & 0xFF;
			var blue:Number = rgb >> 0 & 0xFF;
			
			var max:Number = Math.max(Math.max(red, green), blue);
			var min:Number = Math.min(Math.min(red, green), blue);
			
			
			if(red == green && green == blue){
				ret[0] = ret[1] = ret[2] = 0;
				return ret;
			}else{
				if(max == red && min == blue){
					ret[0] = 0 + (green-min)/(max-min)*60;
				}else if(max == green && min == blue){
					ret[0] = 60 + (1-(red-min)/(max-min))*60;
				}else if(max == green && min == red){
					ret[0] = 120 + (blue-min)/(max-min)*60;
				}else if(max == blue && min == red){
					ret[0] = 180 + (1-(green-min)/(max-min))*60;
				}else if(max == blue && min == green){
					ret[0] = 240 + (red-min)/(max-min)*60;
				}else if(max == red && min == green){
					ret[0] = 300 + (1-(blue-min)/(max-min))*60;
				}
				
				ret[1] = (max-min)/max;
				
				ret[2] = max/255;
				
				
				return ret;
			}
		}
		
		public static function getHeikinColor(bmd:BitmapData, xx:Number, yy:Number, w:Number, h:Number):uint{
			var rrr: uint = 0;
			var ggg: uint = 0;
			var bbb: uint = 0;
			for(var y: Number = yy; y < yy+h; ++y){
				for(var x: Number = xx; x < xx+w; ++x){
					var col: uint = bmd.getPixel(x, y);
					rrr += 0xFF & col >> 16;
					ggg += 0xFF & col >> 8;
					bbb += 0xFF & col >> 0;
				}
			}
			rrr /= w*h;
			ggg /= w*h;
			bbb /= w*h;
			
			return int(rrr) << 16 | int(ggg) << 8 | int(bbb);
		}
		
		public static function getKakomi(pt:Array):Array{
			if(pt.length > 0){
				var maxPt:Point = null;
				var minPt:Point = null;
				
				var retPt:Array = new Array();
				
				var minVal:Number = 100000;
				var maxVal:Number = -100000;
				for(var i:Number = 0; i < pt.length; ++i){
					if(minVal > pt[i].x){
						minPt = pt[i];
						minVal = pt[i].x;
					}else if(minVal == pt[i].x){
						if(minPt.y < pt[i].y){
							minPt = pt[i];
						}
					}
				
					if(maxVal < pt[i].x){
						maxPt = pt[i];
						maxVal = pt[i].x;
					}
				}
				retPt.push(minPt);
			
				var korePt:Point = null;
				for(var j:Number = 0; j < pt.length; ++j){
					if(minPt == maxPt)	break;
					var maxK:Number = -100000;
					for(var k:Number = 0; k < pt.length; ++k){
						if(minPt != pt[k]){
							if(pt[k].x > minPt.x){
								if(maxK < (pt[k].y - minPt.y)/(pt[k].x - minPt.x)){
									maxK = (pt[k].y - minPt.y)/(pt[k].x - minPt.x);
									korePt = pt[k];
								}
							}
						}
					}
					retPt.push(korePt);
					minPt = korePt;
				}
				
				minVal = 100000;
				maxVal = -100000;
				for(var m:Number = 0; m < pt.length; ++m){
					if(minVal > pt[m].x){
						minPt = pt[m];
						minVal = pt[m].x;
					}
					if(maxVal < pt[m].x){
						maxPt = pt[m];
						maxVal = pt[m].x;
					}else if(maxVal == pt[m].x){
						if(maxPt.y > pt[m].y){
							maxPt = pt[m];
						}
					}
				
				}
				
				if(retPt[retPt.length-1] != maxPt){
					retPt.push(maxPt);
				}
				
				korePt = null;
				for(var n:Number = 0; n < pt.length; ++n){
					if(maxPt == minPt)	break;
					maxK = -100000;
					for(var q:Number = 0; q < pt.length; ++q){
						if(maxPt != pt[q]){
							if(pt[q].x < maxPt.x){
								if(maxK < (pt[q].y - maxPt.y)/(pt[q].x - maxPt.x)){
									maxK = (pt[q].y - maxPt.y)/(pt[q].x - maxPt.x);
									korePt = pt[q];
								}
							}
						}
					}
					retPt.push(korePt);
					maxPt = korePt;
				}
				
				if(retPt.length > 1 && retPt[retPt.length-1].x == retPt[0].x && retPt[retPt.length-1].y == retPt[0].y){
					retPt.pop();
				}
				
				return retPt;
			}else{
				return null;
			}
		}
		
		public static function jushin(pt:Array):Point{
			if(pt != null){
				if(pt.length == 0){
					return new Point(0, 0);
				}else if(pt.length == 1){
					return new Point(pt[0].x, pt[0].y);
				}else if(pt.length == 2){
					return new Point((pt[0].x+pt[1].x)/2, (pt[0].y+pt[1].y)/2);
				}else{
					var s:Number = 0;
					for(var i:Number = 0; i < pt.length; ++i){
						s += (pt[i].x+pt[(i+1)%pt.length].x)*(pt[(i+1)%pt.length].y-pt[i].y);
					}
					s /= 2;
					
					var gx:Number = 0;
					var gy:Number = 0;
					for(var j:Number = 0; j < pt.length; ++j){
						gx += (pt[j].x*pt[j].x + pt[j].x*pt[(j+1)%pt.length].x + pt[(j+1)%pt.length].x*pt[(j+1)%pt.length].x)*(pt[(j+1)%pt.length].y - pt[j].y);
						gy += (pt[j].y*pt[j].y + pt[j].y*pt[(j+1)%pt.length].y + pt[(j+1)%pt.length].y*pt[(j+1)%pt.length].y)*(pt[j].x - pt[(j+1)%pt.length].x);
					}
					gx /= s*6;
					gy /= s*6;
					return new Point(gx, gy);
				}
			}else{
				return null;
			}
		}

		public static function fillRing(pt: Array, sp: Sprite, col:uint=0x000000, al:Number = 1):void{
			if(pt.length >= 3){
				sp.graphics.moveTo((pt[pt.length-1].x+pt[0].x)/2, (pt[pt.length-1].y+pt[0].y)/2);
				sp.graphics.beginFill(col, al);
				for(var i:Number = 0; i < pt.length; ++i){
					sp.graphics.curveTo(pt[i].x, pt[i].y, (pt[i].x+pt[(i+1) % pt.length].x)/2, (pt[i].y+pt[(i+1) % pt.length].y)/2);
				}
				sp.graphics.endFill();
			}  
		}
		
		public static function drawPolygon(pt: Array, sp: Sprite):void{
			if(pt.length >= 3){
				sp.graphics.moveTo(pt[0].x, pt[0].y);
				for(var i:Number = 1; i < pt.length; ++i){
					sp.graphics.lineTo(pt[i].x, pt[i].y);
				}
				sp.graphics.lineTo(pt[0].x, pt[0].y);
			}  
		}
		
		public static function getVoronoiAreas(pt: Array, rect:Rectangle):Array{
			for(var i:Number = 0; i < pt.length; ++i){
				if(pt[i] is Point){
				
				}else{
					trace("Array引数の中にPoint型ではないものが含まれています。");
					return null;
				}
			}
		
			var ret:Array = new Array();
			for(var j:Number = 0; j < pt.length; ++j){
				ret.push(new Array());
				ret[ret.length-1].push(new Point(rect.left, rect.top));
				ret[ret.length-1].push(new Point(rect.right, rect.top));
				ret[ret.length-1].push(new Point(rect.right, rect.bottom));
				ret[ret.length-1].push(new Point(rect.left, rect.bottom));
			}
			for(var m:Number = 0; m < pt.length; ++m){
				for(var n:Number = 0; n < pt.length; ++n){
					if(m != n){
						var sui:Array = suichoku2toubunsen(pt[m], pt[n]);
						var counter:Number = 0;
						var koutenPt:Array = new Array();
						var startPtNum:Array = new Array;
						for(var k:Number = 0; k < ret[m].length; ++k){
							var pp:Point = kouten(ret[m][k], ret[m][(k+1)%(ret[m].length)], sui);
							if(pp != null){
								++counter;
								koutenPt.push(pp);
								startPtNum.push(k);
							}
						}
				
						if(counter == 2){
							var temp0:Array = ret[m].slice(0, startPtNum[0]+1);
							var temp1:Array = ret[m].slice(startPtNum[0]+1, startPtNum[1]+1);
							var temp2:Array = ret[m].slice(startPtNum[1]+1);
							var temp:Array;
							var g1:Number;
							var g2:Number;
							if(temp0 != null){
								if(temp0.length > 0){
									g1 = gaiseki(koutenPt[0], koutenPt[1], temp0[0]);
									g2 = gaiseki(koutenPt[0], koutenPt[1], pt[m]);
									if(g1*g2 >= 0){
										temp = temp0.concat([koutenPt[0]]);
									}else{
										temp = [koutenPt[0]];
									}
								}
							}
							if(temp1 != null){
								if(temp1.length > 0){
									g1 = gaiseki(koutenPt[0], koutenPt[1], temp1[0]);
									g2 = gaiseki(koutenPt[0], koutenPt[1], pt[m]);
									if(g1*g2 >= 0){
										temp = temp.concat(temp1, [koutenPt[1]]);
									}else{
										temp = temp.concat([koutenPt[1]]);
									}
								}
							}
							if(temp2 != null){
								if(temp2.length > 0){
									g1 = gaiseki(koutenPt[0], koutenPt[1], temp2[0]);
									g2 = gaiseki(koutenPt[0], koutenPt[1], pt[m]);
									if(g1*g2 >= 0){
										temp = temp.concat(temp2);
									}
								}
							}
							ret[m] = temp;
						}
					}
				}
			}
			
			return ret;
		}
		
		public static function gaiseki(p0:Point, p1:Point, pt:Point):Number{
			var		ret:Number;
			var		ax:Number, ay:Number, bx:Number, by:Number;
			ax = pt.x - p0.x;	ay = pt.y - p0.y;
			bx = p1.x - p0.x;	by = p1.y - p0.y;
			ret = ax*by - bx*ay;
			return ret;
		}
		
		public static function suichoku2toubunsen(p0:Point, p1:Point):Array{
			var ret:Array = new Array();
			
			if(p0 != null && p1 != null){
				if(p0.y == p1.y){
					ret.push((p0.x+p1.x)/2);
					return ret;
				}else{
					var katamuki:Number = -(p1.x-p0.x)/(p1.y-p0.y);
					var cp:Point = new Point((p0.x+p1.x)/2, (p0.y+p1.y)/2);
					var seppen:Number = cp.y - katamuki*cp.x;
					ret.push(katamuki);
					ret.push(seppen);
					return ret;
				}
			}
			return null;
		}
		
		public static function kouten(p0:Point, p1:Point, sen:Array):Point{
			if(sen != null){
				if(sen.length == 1){
					if(p0.x == p1.x){
						if(p0.y == p1.y && sen[0] == p0.x){
							return new Point(p0.x, p0.y);
						}else{
							return null;
						}
					}else{
						var katamuki:Number = (p1.y-p0.y)/(p1.x-p0.x);
						var seppen:Number = p0.y - katamuki*p0.x;
						
						var ix:Number = sen[0];
						var iy:Number = katamuki*ix + seppen;
						if(iy <= Math.max(p0.y, p1.y) && iy >= Math.min(p0.y, p1.y)){
							return new Point(ix, iy);
						}else{
							return null;
						}
					}
				}else{
					if(p0.x == p1.x){
						var jx:Number = p0.x;
						var jy:Number = sen[0]*jx + sen[1];
						if(jy <= Math.max(p0.y, p1.y) && jy >= Math.min(p0.y, p1.y)){
							return new Point(jx, jy);
						}else{
							return null;
						}
					}else{
						var katamuki2:Number = (p1.y-p0.y)/(p1.x-p0.x);
						var seppen2:Number = p0.y - katamuki2*p0.x;
						
						if(katamuki2 == sen[0]){
							return null;
						}else{
							var kx:Number = (sen[1] - seppen2)/(katamuki2 - sen[0]);
							var ky:Number = katamuki2*kx + seppen2;
						
							if(kx <= Math.max(p0.x, p1.x) && kx >= Math.min(p0.x, p1.x)){
								return new Point(kx, ky);
							}else{
								return null;
							}
						}
					}
				}
			}
			return null;
		}
		
		public static function bezierCurveTo(x0:Number,y0:Number,x1:Number,y1:Number,x2:Number,y2:Number,x3:Number,y3:Number,sp:Sprite):void{
			var div:Number=16;
			var pt:Array=new Array();
			
			for (var i:Number=0; i<=div; ++i) {
				var t:Number=i/div;
				var w0:Number=(1-t)*(1-t)*(1-t);
				var w1:Number=3*t*(1-t)*(1-t);
				var w2:Number=3*t*t*(1-t);
				var w3:Number=t*t*t;
				var x:Number=w0*x0+w1*x1+w2*x2+w3*x3;
				var y:Number=w0*y0+w1*y1+w2*y2+w3*y3;
				
				pt.push(new Point(x,y));
			}
			drawContinuousCurve(pt,sp);
		}
		
		public static function drawContinuousCurve(pt: Array, sp: Sprite):void{
			if(pt.length >= 3){
				sp.graphics.lineTo(pt[0].x, pt[0].y);
				for(var i:Number = 1; i <= pt.length-3; ++i){
					sp.graphics.curveTo(pt[i].x, pt[i].y, (pt[i].x+pt[i+1].x)/2, (pt[i].y+pt[i+1].y)/2);      
				}
				sp.graphics.curveTo(pt[pt.length-2].x, pt[pt.length-2].y, pt[pt.length-1].x, pt[pt.length-1].y);
			}  
		}
	}
}