﻿package{
	import flash.display.MovieClip;
	import flash.utils.Timer;
	import flash.events.Event;
	import flash.events.TimerEvent;
	import flash.events.MouseEvent;
	import flash.events.KeyboardEvent;
	import flash.geom.Point;
	import flash.net.URLRequest;
	import flash.net.URLLoader;
	import flash.net.URLLoaderDataFormat;
	
	import FMPhysics.BezierShape;
	import FMPhysics.PhysicalPoint;
	import FMPhysics.FMButton;

	public class RecordShape extends MovieClip{
		var bs:BezierShape;
		var shapeHistory:Array = new Array();
		var draggingAnchorPt:PhysicalPoint = null;
		var draggingHokoPts:Array = null;
		var ctrlDrawFlag:Boolean = true;
		var historyDrawFlag:Boolean = true;
		var playingFlag:Boolean = false;
		var ctrlAlpha:Number = 0;
		var historyAlpha:Number = 0;
		var startTime:Number;
		
		var playBt:FMButton;

		var preMouseX:Number, preMouseY:Number;
		var curMouseX:Number, curMouseY:Number;
		
		var timer:Timer;
		
		function RecordShape(){
			var xmlLoader:URLLoader = new URLLoader();
			xmlLoader.dataFormat = URLLoaderDataFormat.TEXT;
			xmlLoader.addEventListener(Event.COMPLETE, onXMLLoaded);
			xmlLoader.load(new URLRequest("shape.xml"));
		}

		function onXMLLoaded(event:Event):void{
			try{
				var xml:XML = new XML(event.target.data);
				bs = new BezierShape(xml);
				bs.expand(1, -1);
				bs.shift(stage.stageWidth/2, stage.stageHeight/2);
				
				stage.addEventListener(MouseEvent.MOUSE_DOWN, onMDown);
				stage.addEventListener(MouseEvent.MOUSE_UP, onMUp);
				stage.addEventListener(KeyboardEvent.KEY_DOWN, onKDown);
				
				playBt = new FMButton("play");
				playBt.x = 20;
				playBt.y = 540;
				addChild(playBt);
				playBt.addEventListener(MouseEvent.CLICK, function(ev:MouseEvent){
					playingFlag = !playingFlag;
					setByPlayingFlag();
				});
				
				var ctrlViewBt:FMButton = new FMButton("view control");
				ctrlViewBt.x = 20;
				ctrlViewBt.y = 560;
				addChild(ctrlViewBt);
				ctrlViewBt.addEventListener(MouseEvent.CLICK, function(ev:MouseEvent){
					ctrlDrawFlag = !ctrlDrawFlag;
				});
				
				var historyViewBt:FMButton = new FMButton("view history");
				historyViewBt.x = 20;
				historyViewBt.y = 580;
				addChild(historyViewBt);
				historyViewBt.addEventListener(MouseEvent.CLICK, function(ev:MouseEvent){
					historyDrawFlag = !historyDrawFlag;
				});
				
				var resetBt:FMButton = new FMButton("reset history");
				resetBt.x = 20;
				resetBt.y = 600;
				addChild(resetBt);
				resetBt.addEventListener(MouseEvent.CLICK, function(ev:MouseEvent){
					shapeHistory = new Array();
				});

				preMouseX = curMouseX = mouseX;
				preMouseY = curMouseY = mouseY;
				
				timer = new Timer(33);
				timer.addEventListener(TimerEvent.TIMER, loop);
				timer.start();
			}catch(err:TypeError){
				trace(err);
			}
		}
		
		function setByPlayingFlag(){
			if(playingFlag){
				playBt.setCaption("stop");
				if(shapeHistory.length > 0){
					bs = shapeHistory[0].duplicate();
				}
				startTime = new Date().getTime();
			}else{
				playBt.setCaption("play");
				if(shapeHistory.length > 0){
					bs = shapeHistory[shapeHistory.length-1].duplicate();
				}
			}
		}
		
		function onMDown(ev:MouseEvent){
			draggingAnchorPt = bs.getAnchorPoints(new Point(ev.target.mouseX, ev.target.mouseY));
			if(draggingAnchorPt == null){
				draggingHokoPts = bs.getHokoPoints(new Point(ev.target.mouseX, ev.target.mouseY));
			}else{
				draggingHokoPts = bs.getHokoPoints2(draggingAnchorPt);
			}
		}
		
		function onMUp(ev:MouseEvent){
			draggingAnchorPt = null;
			draggingHokoPts = null;
		}
		
		function onKDown(ev:KeyboardEvent){
			if(ev.keyCode == 32){
				if(!playingFlag){
					shapeHistory.push(bs.duplicate());
				}
			}
		}
		
		function loop(event:TimerEvent):void{
			preMouseX = curMouseX;
			preMouseY = curMouseY;
			curMouseX = mouseX;
			curMouseY = mouseY;
			
			if(draggingAnchorPt != null){
				draggingAnchorPt.x += curMouseX - preMouseX;
				draggingAnchorPt.y += curMouseY - preMouseY;
			}
			if(draggingHokoPts != null){
				for(var j:Number = 0; j < draggingHokoPts.length; ++j){
					draggingHokoPts[j].x += curMouseX - preMouseX;
					draggingHokoPts[j].y += curMouseY - preMouseY;
				}
			}
			
			if(playingFlag){
				if(shapeHistory.length > 0){
					var nowTime:Number = new Date().getTime();
					var intervalTime:Number = 700;
					var num:Number = Math.min(int((nowTime-startTime)/intervalTime)+1, shapeHistory.length-1);
					
					for(var s:Number = 0; s < bs.loc.length; ++s){
						for(var t:Number = 0; t < bs.loc[s].length; ++t){
							for(var u:Number = 0; u < bs.loc[s][t].length; ++u){
								var nexx:Number = shapeHistory[num].loc[s][t][u].x;
								var nexy:Number = shapeHistory[num].loc[s][t][u].y;
								var prex:Number = shapeHistory[num-1].loc[s][t][u].x;
								var prey:Number = shapeHistory[num-1].loc[s][t][u].y;
								
							//	bs.loc[s][t][u].setKasokudo((nexx-bs.loc[s][t][u].x)*15, (nexy-bs.loc[s][t][u].y)*15);
								
							//	bs.loc[s][t][u].x += (nexx - bs.loc[s][t][u].x)/10;
							//	bs.loc[s][t][u].y += (nexy - bs.loc[s][t][u].y)/10;
							
								var byo:Number = (nowTime-startTime) - (num-1)*intervalTime;
								bs.loc[s][t][u].x = prex + byo/intervalTime*(nexx-prex);
								bs.loc[s][t][u].y = prey + byo/intervalTime*(nexy-prey);
							}
						}
					}
					
					if(nowTime - startTime > intervalTime*(shapeHistory.length-1)){
						playingFlag = false;
						setByPlayingFlag();
					}
				}
			}
			
			if(ctrlDrawFlag)	ctrlAlpha = Math.min(ctrlAlpha+0.2, 1);
			else				ctrlAlpha = Math.max(ctrlAlpha-0.2, 0);
			if(historyDrawFlag)	historyAlpha = Math.min(historyAlpha+0.2, 1);
			else				historyAlpha = Math.max(historyAlpha-0.2, 0);
			
			this.graphics.clear();
			this.graphics.lineStyle(1, 0x000000);
			bs.drawShape(this);
			if(ctrlAlpha != 0){
				this.graphics.lineStyle(1, 0xFF0000, ctrlAlpha);
				bs.drawControl(this);
			}

			if(historyAlpha != 0){
				for(var n:Number = 0; n < shapeHistory.length; ++n){
					this.graphics.lineStyle(1, 0x000000, historyAlpha*0.1);
					shapeHistory[n].drawShape(this);
				}
			}
		}
	}
}
